#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "./verify550.h"

void VerificationFailure(const char *exp, const char *file,
                      const char *baseFile, int line) {
  if (!strcmp(file, baseFile)) {
    fprintf(stderr,
            "Verify550(%s) failed in file %s, line %d\n", exp, file, line);
  } else {
    fprintf(stderr,
            "Verify550(%s) failed in file %s (included from %s), line %d\n",
            exp, file, baseFile, line);
  }
  exit(EXIT_FAILURE);
}