#ifndef VERIFY550_H_
#define VERIFY550_H_

#include <stdint.h>  // for uint32_t, etc.

//   http://www.acm.uiuc.edu/sigops/roll_your_own/2.a.html

void VerificationFailure(const char *exp, const char *file,
                         const char *basefile, int line);

#define Verify550(exp) if (exp) ; \
  else VerificationFailure(#exp, __FILE__, __BASE_FILE__, __LINE__)

#endif  // VERIFY550_H_