import socket, sys
import pickle
import json
from message import * # Can change this after testing done
import paxos

# Client to send lock / unlock to servers
class Client:
    def __init__(self, server_addrs) -> None:
        self.server_addrs = server_addrs

    # Returns true if lock is successful, false otherwise
    # x : value to lock (int)
    def lock(self, x) -> bool:
        json = {"op": "lock", "value": x}
        for server_addr in self.server_addrs:
            pass
            # Send JSON to servers, will be treated as command
        # Wait for response to return

    # Returns true if unlock is successful, false otherwise
    # x : value to lock (int)
    def unlock(self, x) -> bool:
        json = {"op": "unlock", "value": x}
        for server_addr in self.server_addrs:
            pass
            # Send JSON to servers, will be treated as command
        # Wait for response to return


if __name__ == "__main__":
    HOST, PORT = "localhost", 9999
    
    paxos_req = PaxosRequest((HOST, PORT), LockCommand("lock", 0))
    # paxos_req = P1A((HOST, PORT), paxos.BallotNumber(2, (HOST, PORT)))
    data = pickle.dumps(paxos_req)
    print(paxos_req, "\n")
    print(data, "\n")
    de_paxos_req = pickle.loads(data)
    print(de_paxos_req, "\n")
    #data = " ".join(sys.argv[1:])
    #print('data = %s' %data)
    # create a TCP socket
    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    try:
        # connect to server 
        sock.connect((HOST, PORT))

        # send data
        #sock.sendall(bytes(data + "\n"))
        sock.sendall(data)

        # receive data back from the server
        received = sock.recv(1024)
    finally:
        # shut down
        sock.close()

    print("Sent:     {}".format(data))
    print("Received: {}".format(str(received)))
    print("Received Deserialize: {}".format(pickle.loads(received)))
