import dslabs.atmostonce.AMOCommand;
import dslabs.framework.Timer;
import dslabs.paxos.PaxosServer.BallotNumber;
import lombok.Data;

@Data
final class ClientTimer implements Timer {
    static final int CLIENT_RETRY_MILLIS = 100;

    // Your code here...
    private final AMOCommand amoCommand;
}

// Your code here...

@Data
final class P2ATimer implements Timer {
    static final int P2A_RETRY_MILLIS = 100;

    private final P2A p2a;
}

@Data
final class HeartBeatTimer implements Timer {
    static final int HEARTBEAT_RETRY_MILLIS = 20;
}

@Data
final class HeartBeatCheckTimer implements Timer {
    static final int HEARTBEAT_CHECK_RETRY_MILLIS = 100;

    private final BallotNumber ballotNumber;
}

@Data
final class LeaderElectionTimer implements Timer {
    static final int LEADER_ELECTION_TIMER = 50;

    private final P1A p1a;
}
